package objekty;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Timer;
import java.util.TimerTask;

public class FrameMain
    extends JFrame {
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  Pohled kresliciPlocha = new Pohled();
  Model model = new Model();
  Rizeni rizeni = new Rizeni();

  //Construct the frame
  public FrameMain() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    contentPane = (JPanel)this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(800, 600));
    this.setTitle("Potape");
    kresliciPlocha.setBorder(null);
    kresliciPlocha.setText("");
    kresliciPlocha.addMouseMotionListener(new
        FrameMain_kresliciPlocha_mouseMotionAdapter(this));
    kresliciPlocha.addKeyListener(new FrameMain_kresliciPlocha_keyAdapter(this));
    kresliciPlocha.model = model; //propojeni modelu
    rizeni.model = model;
    kresliciPlocha.addMouseListener(new FrameMain_kresliciPlocha_mouseAdapter(this));
    contentPane.add(kresliciPlocha, BorderLayout.CENTER);
    int prodleva = 1000; // prodleva 5 sek. pro 5000
    int perioda = 5000; // opakuj kazdou sekundu pro 10000
    Timer timer = new Timer();

    timer.scheduleAtFixedRate(new TimerTask() {
      public void run() {
        rizeni.ticTak();
        repaint();
      }
    }

    , prodleva, perioda);

  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void kresliciPlocha_mouseClicked(MouseEvent e) {
    rizeni.mysKlik(e);
    repaint();
  }

  void kresliciPlocha_keyPressed(KeyEvent e) {
    rizeni.klavesaDolu(e);
    repaint();
  }

  void kresliciPlocha_keyReleased(KeyEvent e) {
    rizeni.klavesaNahoru(e);
    repaint();
  }

  void kresliciPlocha_mouseMoved(MouseEvent e) {
    rizeni.mysPohyb(e);
  }

  void kresliciPlocha_mousePressed(MouseEvent e) {
    rizeni.mysDolu(e);
  }

  void kresliciPlocha_mouseReleased(MouseEvent e) {
    rizeni.mysNahoru(e);
  }

}

class FrameMain_kresliciPlocha_mouseAdapter
    extends java.awt.event.MouseAdapter {
  FrameMain adaptee;

  FrameMain_kresliciPlocha_mouseAdapter(FrameMain adaptee) {
    this.adaptee = adaptee;
  }

  public void mouseClicked(MouseEvent e) {
    adaptee.kresliciPlocha_mouseClicked(e);
  }

  public void mousePressed(MouseEvent e) {
    adaptee.kresliciPlocha_mousePressed(e);
  }

  public void mouseReleased(MouseEvent e) {
    adaptee.kresliciPlocha_mouseReleased(e);
  }
}

class FrameMain_kresliciPlocha_keyAdapter
    extends java.awt.event.KeyAdapter {
  FrameMain adaptee;

  FrameMain_kresliciPlocha_keyAdapter(FrameMain adaptee) {
    this.adaptee = adaptee;
  }

  public void keyPressed(KeyEvent e) {
    adaptee.kresliciPlocha_keyPressed(e);
  }

  public void keyReleased(KeyEvent e) {
    adaptee.kresliciPlocha_keyReleased(e);
  }
}

class FrameMain_kresliciPlocha_mouseMotionAdapter
    extends java.awt.event.MouseMotionAdapter {
  FrameMain adaptee;

  FrameMain_kresliciPlocha_mouseMotionAdapter(FrameMain adaptee) {
    this.adaptee = adaptee;
  }

  public void mouseMoved(MouseEvent e) {
    adaptee.kresliciPlocha_mouseMoved(e);
  }
}
